SystemOrganization addCategory: #KinematicTemplates!

SystemWindow subclass: #KinematicWindow
	instanceVariableNames: 'virtualCursor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

KinematicWindow class
	instanceVariableNames: 'uniqueInstance'!

KinematicWindow class
	instanceVariableNames: 'uniqueInstance'!

!KinematicWindow class methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 18:50'!
openExample
	|w tpl1 tpl2| 
	w := self new .
	tpl1 := StraightLineTemplate new height: 300; width: 300; top: 30.
	w addMorphBack: tpl1.
	
	tpl2 := CompassTemplate new height: 300; width: 300; top: 30; left: tpl1 width.
	tpl2 color: Color red.
	w addMorphBack: tpl2.
	
	w openInWorld.! !

!KinematicWindow methodsFor: 'accessing' stamp: 'carlaGriggio 12/13/2012 00:45'!
handlesMouseOver: evt
	^true! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/13/2012 03:09'!
initialize
	super initialize.
	virtualCursor := RectangleMorph new width: 10; height: 10; color: Color red.
	self addMorph: virtualCursor.

	
	self setLabel:'Kinematic Templates'.! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/13/2012 00:45'!
mouseEnter: event
	super mouseEnter: event.
	self currentHand showTemporaryCursor: Cursor blank.! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/13/2012 00:45'!
mouseLeave: event
	super mouseEnter: event.
	self currentHand showTemporaryCursor: nil! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/5/2012 09:54'!
virtualCursor
	^virtualCursor ! !

RectangleMorph subclass: #KinematicTemplate
	instanceVariableNames: 'drawnPath lastDrawnPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

KinematicTemplate subclass: #CompassTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!CompassTemplate methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 18:50'!
transformedDelta: realDelta
	| shiftPoint origR origTheta newR newTheta finalR finalTheta |

	shiftPoint := lastDrawnPoint - 500.
	
	origR := shiftPoint r.
	origTheta := shiftPoint theta.
	
	newR := (shiftPoint + realDelta) r.
	newTheta := (shiftPoint + realDelta) theta.
	
	finalR := (newR - origR) * 0.2 + origR.
  	finalTheta := (newTheta - origTheta) + origTheta.
	
	^Point 
		x: finalR * finalTheta cos - shiftPoint x
		y: finalR * finalTheta sin - shiftPoint y.
		
"		^(Point r: finalR degrees: finalTheta degrees) + (sign * shiftPoint)"! !

!KinematicTemplate class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/5/2012 09:47'!
openExample
	|w tpl|
	w := SystemWindow new setLabel:'Kinematic Templates'.
	tpl := self new height: 300; width: 300; top: 30.
	w addMorph: tpl.
	w openInWorld.! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/13/2012 03:24'!
handleMouseMove: anEvent
	"The virtualCursor is a submorph of the KinematicWindow, and apparently changing it's position makes this template lose the mouse focus. It's very important to recover the mouse focus so the mouseMove: message is sent to this template"
	self virtualCursor position: anEvent cursorPoint. self currentHand mouseFocus: self.
	super handleMouseMove: anEvent
! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/13/2012 01:57'!
handlesMouseDown: anEvent
	^true! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/13/2012 02:01'!
mouseDown: event
	super mouseDown: event.
	lastDrawnPoint := event cursorPoint.! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 18:15'!
mouseMove: event
	| realDelta delta |
	realDelta := event endPoint - event startPoint.
	lastDrawnPoint ifNil: [ lastDrawnPoint := event startPoint ].
	
	delta := self transformedDelta: realDelta.

	drawnPath 
		ifNil: [
			drawnPath  := LineMorph from: lastDrawnPoint to: lastDrawnPoint + delta color: Color black width: 2.
			drawnPath openInWorld ]
		ifNotNil: [
			drawnPath setVertices: (drawnPath vertices copyWith: lastDrawnPoint + delta) ].
		
	self virtualCursor position: lastDrawnPoint + delta. 
		
	lastDrawnPoint := lastDrawnPoint + delta.
	
! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/13/2012 02:12'!
mouseUp: event

	
	drawnPath ifNotNil: [self addMorph: drawnPath].
	drawnPath := nil.
	lastDrawnPoint := nil.! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/6/2012 23:13'!
virtualCursor
	^ self containingWindow virtualCursor ! !

KinematicTemplate subclass: #StraightLineTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!StraightLineTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/13/2012 01:13'!
transformedDelta: realDelta
	^ (realDelta x * 1) @ (realDelta y * 0.1)! !
